// 			Fragile Base Class problem and solutions
//
// An enhancement to class Strstream supporting a concurrent access
// to a string stream. It is added by Vendor A to version 2 of his
// C++ stream library.

#include "iostream_v1.h"

class strstream_v2 : virtual public Strstream
{
	int mutex;
	
public:
    strstream_v2(void);
    virtual ~strstream_v2(void);
   	virtual void lock(const bool onoff);
   	char *str(void) { lock(true); return Strstream::str(); }
	void freeze(const int n = 1);
    bool frozen(void) const;
};
